/*-
 * Copyright (C) @BABOLO  2003 Apr 15
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2003 Apr 15\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: cvs-anon-shell.c,v 1.3 2008/09/26 09:36:04 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sys/stat.h>
#include <sysexits.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <stdarg.h>
#include <stdio.h>

#ifndef SHEL
# define SHEL "cvs-anon-shell"
#endif
#ifndef CVSROOT
# define CVSROOT "/repo"
#endif
#ifndef CVS
# define CVS "/usr/libexec/cvs"
#endif
#ifndef HOME
# define HOME "/etc/home"
#endif
#ifndef TMPD
# define TMPD "/var/tmp"
#endif

char *env[] =
{ "USER=anoncvs"
, "PATH="
, "TMPDIR="TMPD
, "CVSROOT="CVSROOT
, "CVSREADONLYFS=1"
, NULL
};

int
main(int argc, char **argv) {
    int i;

    openlog(SHEL, LOG_PID, LOG_SECURITY);
    umask(002);
    if  (  argc != 3 || !argv) {
        syslog(LOG_ERR, "%d and void", argc);
        exit(EX_DATAERR);
    }
    for (i = 0; i < 3; i++) {
        if  (!argv[i]) {
            syslog(LOG_ERR, "%d and void %d", argc, i);
            exit(EX_DATAERR);
    }   }
    if  (  strcmp(SHEL, argv[0])
        || strcmp("-c", argv[1])
        ) {
        syslog(LOG_ERR, "Illegal 0 or 1: %s %s", argv[0], argv[1]);
        exit(EX_DATAERR);
    }
    if  (  strcmp("cvs server", argv[2])
        && strcmp("cvs -d "CVSROOT" server", argv[2])
        ) {
        syslog(LOG_ERR, "Illegal 2: %s", argv[2]);
        exit(EX_DATAERR);
    }
    execle(CVS, "cvs", "server", NULL, env);
    syslog(LOG_ERR, "No cvs");
    exit(EX_OSFILE);
}
